env.info("Mission Setup : is loading.")

function merge(tbls)
	local res = {}
	for i,v in ipairs(tbls) do
		for i2,v2 in ipairs(v) do
			table.insert(res,v2)
		end
	end
	
	return res
end

function allExcept(tbls, except)
	local tomerge = {}
	for i,v in pairs(tbls) do
		if i~=except then
			table.insert(tomerge, v)
		end
	end
	return merge(tomerge)
end

upgrades = {
	redships = {
		blue = {'blueShip', 'blueShip', 'blueShip'},
		red = {'redShipS', 'redShipS', 'redShipM', 'redShipL', 'redShipL', 'redShipXL'}
	},
	blueships = {
		blue = {'blueShip'},
		red = {'redShipXL'}
	},
	airfield = {
		blue = {'bluePD1'},
		red = {'redInfantry1', 'redArmor1', 'redArmor2', 'redPD1', 'redPD2'}
	},
	airfield1 = {
		blue = {'blueInfantry', 'blueArmor', 'bluePD1'},
		red = {'redInfantry1', 'redInfantry2', 'redArmor1', 'redArmor2', 'redPD1'}
	},
	
	airfield2 = {
		blue = {'blueInfantry', 'blueArmor', 'bluePD1'},
		red = {'redInfantry1', 'redArmor1', 'redArmor2', 'redPD1', 'redPD2'}
	},
	airfield3 = {
		blue = {'blueInfantry', 'blueArmor', 'bluePD2', 'blueHAWK'},
		red = {'redInfantry2', 'redArmor1', 'redArmor2', 'redPD2', 'redPD3'}
	},
	airfield6 = {
		blue = {'blueInfantry', 'blueArmor', 'bluePD1', 'bluePATRIOT'},
		red = {'redInfantry2', 'redArmor1', 'redArmor2', 'redPD2', 'redPD3'}
	},
	airfield4 = {
		blue = {'blueInfantry','blueArmor', 'bluePD2'},
		red = {'redInfantry2', 'redArmor1', 'redArmor2', 'redPD3', 'redPD4'}
	},
	sam1 = {
		blue = {'bluePD1', 'bluePD1'},
		red = {'redPD1', 'redSA2'}
	},
	sam2 = {
		blue = {'bluePD2', 'bluePD1'},
		red = {'redPD2', 'redSA3'}
	},
	sam3 = {
		blue = {'bluePD1', 'blueHAWK'},
		red = {'redPD3', 'redSA6'}
	},
	sam4 = {
		blue = {'bluePD2', 'blueHAWK'},
		red = {'redPD3','redSA10'}
	},
	sam5 = {
		blue = {'bluePD1', 'bluePATRIOT'},
		red = {'redPD4', 'redSA11'}
	},
	sam6 = {
		blue = {'bluePD2', 'bluePATRIOT'},
		red = {'redPD4', 'redSA5'}
	},
	farp1 = {
		blue = {'blueInfantry', 'blueArmor', 'bluePD1'},
		red = {'redInfantry1', 'redArmor1', 'redPD1'}
	},
	farp2 = {
		blue = {'blueInfantry', 'blueArmor', 'bluePD1'},
		red = {'redInfantry1', 'redArmor1', 'redPD2'}
	},
	farp3 = {
		blue = {'blueInfantry', 'blueArmor', 'bluePD2'},
		red = {'redInfantry2', 'redArmor2', 'redPD3'}
	},
	farp4 = {
		blue = {'blueInfantry', 'blueArmor', 'bluePD2'},
		red = {'redInfantry2', 'redArmor2', 'redPD4'}
	},
	mission1 = {
		blue = {'blueInfantry', 'blueArmor'},
		red = {'redInfantry1', 'redInfantry2', 'redArmor1', 'redPD1'}
	},
	mission2 = {
		blue = {'blueInfantry', 'blueArmor'},
		red = {'redInfantry1', 'redInfantry2', 'redArmor2', 'redPD2'}
	},
	mission3 = {
		blue = {'blueInfantry', 'blueArmor'},
		red = {'redInfantry2', 'redArmor1', 'redArmor2', 'redPD3'}
	},
	mission4 = {
		blue = {'blueInfantry', 'blueArmor'},
		red = {'redInfantry2', 'redArmor1', 'redArmor2', 'redPD4'}
	}
}

flavor = {
	redcarrier = 'Enemy carrier zone',
	bluecarrier = 'WPT \nStart zone',
	bengurion = 'WPT 1\n',
	telnof = 'WPT 2\n',
	kedemhatzerim = 'WPT 3\n',
	nevatim = 'WPT 4\n',
	ramonairbase = 'WPT 5\n',
	elgora = 'WPT 6\n',
	elarish = 'WPT 7\n',
	ovda = 'WPT 10\n',
	stcatherine = 'WPT 15\n',
	aburudeis = 'WPT 19\n',
	birhasanah = 'WPT 23\n',
	melez = 'WPT 24\n',
	baluza = 'WPT 26\n',
	assalihiyah = 'WPT 30\n',
	
	abusuwayr = 'WPT 31\n', 
	fayed = 'WPT 33\n',
	kibritairbase = 'WPT 34\n',
	almansurah = 'WPT 28\n',
	azzaqaziq = 'WPT 40\n',
	bilbeisairbase = 'WPT 39\n',
	cairointernationalairbort = 'WPT 37\n',
	wadialjandali = 'WPT 35\n',
	cairowest = 'WPT 42\n',
	
	farpalpha = 'WPT 9\n',
	farpbravo = 'WPT 10\n',
	farpcharlie = 'WPT 12\n',
	farpdelta = 'WPT 13\n',
	farpecho = 'WPT 14\n',
	farpfoxtrot = 'WPT 17\n',
	farpgolf = 'WPT 16\n',
	farphotel = 'WPT 18\n',
	farpindia = 'WPT 20\n',
	farpjuliett = 'WPT 21\n',
	farpkilo = 'WPT 22\n', 
	farplima= 'WPT 25\n',
	farpmike= 'WPT 35\n',
	farpnovember= 'WPT 30\n',
	
	
	miningfacility = 'WPT \n',
	insurgentcamp = 'WPT \n',
	secrettechfacility = 'WPT \n',
	fueldepo = 'WPT \n',
	ammonitiondepo = 'WPT \n',
	tankfactory = 'WPT \n',
	chemsite = 'WPT \n',
	missilefactory = 'WPT \n',
	
	
	samalpha = 'WPT \n',
	sambravo = 'WPT \n',
	samcharlie = 'WPT \n',
	samdelta = 'WPT \n',
	samecho = 'WPT \n',
	samfoxtrot = 'WPT \n',
	samgolf = 'WPT \n',
	samhotel = 'WPT \n',
	samindia = 'WPT \n',
	samjuliett = 'WPT \n',
	
}
local filepath = 'FootHold_SI_v0.2.lua'
if lfs then 
	local dir = lfs.writedir()..'Missions/Saves/'
	lfs.mkdir(dir)
	filepath = dir..filepath
	env.info('Foothold - Save file path: '..filepath)
end
bc = BattleCommander:new(filepath, 10, 60)
zones = {
	redcarrier = ZoneCommander:new({zone='Red Carrier', side=1, level=6, upgrades=upgrades.redships, crates={}, flavorText=flavor.redcarrier}),
	bluecarrier = ZoneCommander:new({zone='Blue Carrier', side=2, level=1, upgrades=upgrades.blueships, crates={}, flavorText=flavor.bluecarrier}),
	
	bengurion = ZoneCommander:new({zone='Ben-Gurion', side=2, level=1, upgrades=upgrades.airfield, crates={}, flavorText=flavor.bengurion}),
	telnof = ZoneCommander:new({zone='Tel Nof', side=2, level=3, upgrades=upgrades.airfield4, crates={}, flavorText=flavor.telnof}),
	kedemhatzerim = ZoneCommander:new({zone='Kedem-Hatzerim', side=1, level=5, upgrades=upgrades.airfield2, crates={}, flavorText=flavor.kedemhatzerim}),
	nevatim = ZoneCommander:new({zone='Nevatim', side=1, level=5, upgrades=upgrades.airfield3, crates={}, flavorText=flavor.nevatim}),
	ramonairbase = ZoneCommander:new({zone='Ramon Airbase', side=1, level=5, upgrades=upgrades.airfield4, crates={}, flavorText=flavor.ramonairbase}),
	elgora = ZoneCommander:new({zone='El Gora', side=1, level=5, upgrades=upgrades.airfield1, crates={}, flavorText=flavor.elgora}),
	elarish = ZoneCommander:new({zone='El Arish', side=1, level=5, upgrades=upgrades.airfield2, crates={}, flavorText=flavor.elarish}),
	ovda = ZoneCommander:new({zone='Ovda', side=1, level=5, upgrades=upgrades.airfield3, crates={}, flavorText=flavor.ovda}),
	stcatherine = ZoneCommander:new({zone='St Catherine', side=1, level=3, upgrades=upgrades.airfield4, crates={}, flavorText=flavor.stcatherine}),
	aburudeis = ZoneCommander:new({zone='Abu Rudeis', side=1, level=3, upgrades=upgrades.airfield1, crates={}, flavorText=flavor.aburudeis}),
	birhasanah = ZoneCommander:new({zone='Bir Hasanah', side=1, level=3, upgrades=upgrades.airfield2, crates={}, flavorText=flavor.birhasanah}),
	melez = ZoneCommander:new({zone='Melez', side=1, level=3, upgrades=upgrades.airfield6, crates={}, flavorText=flavor.melez}),
	baluza = ZoneCommander:new({zone='Baluza', side=1, level=5, upgrades=upgrades.airfield4, crates={}, flavorText=flavor.baluza}),
	assalihiyah = ZoneCommander:new({zone='As Salihiyah', side=1, level=2, upgrades=upgrades.airfield1, crates={}, flavorText=flavor.assalihiyah}),
	abusuwayr = ZoneCommander:new({zone='Abu Suwayr', side=1, level=2, upgrades=upgrades.airfield3, crates={}, flavorText=flavor.abusuwayr}),
	fayed = ZoneCommander:new({zone='Fayed', side=1, level=2, upgrades=upgrades.airfield1, crates={}, flavorText=flavor.fayed}),
	kibritairbase = ZoneCommander:new({zone='Kibrit Air Base', side=1, level=2, upgrades=upgrades.airfield2, crates={}, flavorText=flavor.kibritairbase}),
	almansurah = ZoneCommander:new({zone='Al Mansurah', side=1, level=1, upgrades=upgrades.airfield3, crates={}, flavorText=flavor.almansurah}),
	azzaqaziq = ZoneCommander:new({zone='AzZaqaziq', side=1, level=1, upgrades=upgrades.airfield4, crates={}, flavorText=flavor.azzaqaziq}),
	bilbeisairbase = ZoneCommander:new({zone='Bilbeis Air Base', side=1, level=1, upgrades=upgrades.airfield1, crates={}, flavorText=flavor.bilbeisairbase}),
	cairointernationalairbort = ZoneCommander:new({zone='Cairo International Airport', side=1, level=3, upgrades=upgrades.airfield3, crates={}, flavorText=flavor.cairointernationalairbort}),
	wadialjandali = ZoneCommander:new({zone='Wadi al Jandali', side=1, level=1, upgrades=upgrades.airfield4, crates={}, flavorText=flavor.wadialjandali}),
	cairowest = ZoneCommander:new({zone='Cairo West', side=1, level=1, upgrades=upgrades.airfield4, crates={}, flavorText=flavor.cairowest}),
	
	farpalpha = ZoneCommander:new({zone='FARP-Alpha', side=1, level=3, upgrades=upgrades.farp1, crates={}, flavorText=flavor.farpalpha}),
	farpbravo = ZoneCommander:new({zone='FARP-Bravo', side=1, level=2, upgrades=upgrades.farp2, crates={}, flavorText=flavor.farpbravo}),
	farpcharlie = ZoneCommander:new({zone='FARP-Charlie', side=1, level=2, upgrades=upgrades.farp3, crates={}, flavorText=flavor.farpcharlie}),
	farpdelta = ZoneCommander:new({zone='FARP-Delta', side=1, level=2, upgrades=upgrades.farp4, crates={}, flavorText=flavor.farpdelta}), --,income=0.5
	farpecho = ZoneCommander:new({zone='FARP-Echo', side=1, level=2, upgrades=upgrades.farp1, crates={}, flavorText=flavor.farpecho}),
	farpfoxtrot = ZoneCommander:new({zone='FARP-Foxtrot', side=1, level=1, upgrades=upgrades.farp2, crates={}, flavorText=flavor.farpfoxtrot}),
	farpgolf = ZoneCommander:new({zone='FARP-Golf', side=1, level=1, upgrades=upgrades.farp3, crates={}, flavorText=flavor.farpgolf}),
	farphotel = ZoneCommander:new({zone='FARP-Hotel', side=1, level=1, upgrades=upgrades.farp4, crates={}, flavorText=flavor.farphotel}),
	farpindia = ZoneCommander:new({zone='FARP-India', side=1, level=1, upgrades=upgrades.farp1, crates={}, flavorText=flavor.farpindia}),
	farpjuliett = ZoneCommander:new({zone='FARP-Juliett', side=1, level=1, upgrades=upgrades.farp2, crates={}, flavorText=flavor.farpjuliett}),
	farpkilo = ZoneCommander:new({zone='FARP-Kilo', side=1, level=1, upgrades=upgrades.farp3, crates={}, flavorText=flavor.farpkilo}),
	farplima = ZoneCommander:new({zone='FARP-Lima', side=1, level=1, upgrades=upgrades.farp4, crates={}, flavorText=flavor.farplima}),
	farpmike = ZoneCommander:new({zone='FARP-Mike', side=1, level=1, upgrades=upgrades.farp1, crates={}, flavorText=flavor.farpmike}),
	farpnovember = ZoneCommander:new({zone='FARP-November', side=1, level=1, upgrades=upgrades.farp3, crates={}, flavorText=flavor.farpnovember}),
	
	miningfacility = ZoneCommander:new({zone='MiningFacility', side=1, level=4, upgrades=upgrades.mission1, crates={}, flavorText=flavor.miningfacility}),
	insurgentcamp = ZoneCommander:new({zone='InsurgentCamp', side=1, level=4, upgrades=upgrades.mission2, crates={}, flavorText=flavor.insurgentcamp}),
	fueldepo = ZoneCommander:new({zone='FuelDepo', side=1, level=4, upgrades=upgrades.mission4, crates={}, flavorText=flavor.fueldepo}),
	tankfactory = ZoneCommander:new({zone='TankFactory', side=1, level=4, upgrades=upgrades.mission2, crates={}, flavorText=flavor.tankfactory}),
	chemsite = ZoneCommander:new({zone='ChemSite', side=1, level=4, upgrades=upgrades.mission3, crates={}, flavorText=flavor.chemsite}),
	missilefactory = ZoneCommander:new({zone='MissileFactory', side=1, level=4, upgrades=upgrades.sam5, crates={}, flavorText=flavor.missilefactory}),
	ammonitiondepo = ZoneCommander:new({zone='AmmonitionDepo', side=1, level=4, upgrades=upgrades.mission1, crates={}, flavorText=flavor.ammonitiondepo}),
	secrettechfacility = ZoneCommander:new({zone='SecretTechFacility', side=1, level=4, upgrades=upgrades.mission3, crates={}, flavorText=flavor.secrettechfacility}),

	
	samalpha = ZoneCommander:new({zone='SAM-Alpha', side=2, level=1, upgrades=upgrades.sam3, crates={}, flavorText=flavor.samalpha}),
	sambravo = ZoneCommander:new({zone='SAM-Bravo', side=1, level=2, upgrades=upgrades.sam1, crates={}, flavorText=flavor.sambravo}),
	samcharlie = ZoneCommander:new({zone='SAM-Charlie', side=1, level=2, upgrades=upgrades.sam2, crates={}, flavorText=flavor.samcharlie}),
	samdelta = ZoneCommander:new({zone='SAM-Delta', side=1, level=2, upgrades=upgrades.sam3, crates={}, flavorText=flavor.samdelta}),
	samecho = ZoneCommander:new({zone='SAM-Echo', side=1, level=2, upgrades=upgrades.sam5, crates={}, flavorText=flavor.samecho}),
	samfoxtrot = ZoneCommander:new({zone='SAM-Foxtrot', side=1, level=2, upgrades=upgrades.sam1, crates={}, flavorText=flavor.samfoxtrot}),
	samgolf = ZoneCommander:new({zone='SAM-Golf', side=1, level=1, upgrades=upgrades.sam2, crates={}, flavorText=flavor.samgolf}),
	samhotel = ZoneCommander:new({zone='SAM-Hotel', side=1, level=2, upgrades=upgrades.sam3, crates={}, flavorText=flavor.samhotel}),
	samindia = ZoneCommander:new({zone='SAM-India', side=1, level=2, upgrades=upgrades.sam5, crates={}, flavorText=flavor.samindia}),
	samjuliett = ZoneCommander:new({zone='SAM-Juliett', side=1, level=2, upgrades=upgrades.sam4, crates={}, flavorText=flavor.samjuliett})
}

zones.bluecarrier:addGroups({
	GroupCommander:new({name='Carrier-Patrol-Ramon-Airbase', mission='attack', targetzone='Ramon Airbase'}),
	GroupCommander:new({name='Carrier-Support-Tel-Nof', mission='supply', targetzone='Tel Nof'}),
	GroupCommander:new({name='Carrier-Attack-Kedem', mission='attack', targetzone='Kedem-Hatzerim'})
})

zones.telnof:addGroups({
	GroupCommander:new({name='Tel-Nof-Attack-Kedem', mission='attack', targetzone='Kedem-Hatzerim'}),
	GroupCommander:new({name='Tel-Nof-Support-Kedem', mission='supply', targetzone='Kedem-Hatzerim'}),
	GroupCommander:new({name='Tel-Nof-Support-SAM-Alpha', mission='supply', targetzone='SAM-Alpha'})

})
zones.elgora:addGroups({
	GroupCommander:new({name='El-Gora-Support-El-Arish', mission='supply', targetzone='El Arish'})

})
zones.farpalpha:addGroups({
	GroupCommander:new({name='Farp-Alpha-Supply-Farp-Kilo', mission='supply', targetzone='FARP-Kilo'}),
	GroupCommander:new({name='Farp-Alpha-Supply-Ovda', mission='supply', targetzone='Ovda'})
})
zones.farplima:addGroups({
	GroupCommander:new({name='Farp-Lima-Supply-Baluza', mission='supply', targetzone='Baluza'}),
	GroupCommander:new({name='Farp-Lima-Supply-Melez', mission='supply', targetzone='Melez'})
})

zones.kedemhatzerim:addGroups({
	--GroupCommander:new({name='Support-SAM-Alpha', mission='supply', targetzone='SAM-Alpha', type='surface'})
	GroupCommander:new({name='Hatzerim-Attack-Tel-Nof', mission='attack', targetzone='Tel Nof'}),
	GroupCommander:new({name='Hatzerim-Support-Tel-Nof', mission='supply', targetzone='Tel Nof'}),
	GroupCommander:new({name='Kedem-Support-Ramon', mission='supply', targetzone='Ramon Airbase'}),
	GroupCommander:new({name='Kedem-Support-Nevatim', mission='supply', targetzone='Nevatim'}),
	GroupCommander:new({name='Kedem-Support-El Gora', mission='supply', targetzone='El Gora'})
})

zones.birhasanah:addGroups({
	GroupCommander:new({name='Bir-Hasanah-Support-SAM-Echo-Blue', mission='supply', targetzone='SAM-Echo'})
})
zones.ramonairbase:addGroups({
	GroupCommander:new({name='Ramon-Attack-Hatzor', mission='attack', targetzone='Hatzor'}),
	GroupCommander:new({name='Ramon-Attack-Kedem', mission='attack', targetzone='Kedem-Hatzerim'}),
	GroupCommander:new({name='Ramon-Supply-Kedem', mission='supply', targetzone='Kedem-Hatzerim'}),
	GroupCommander:new({name='Ramon-Supply-Nevatim', mission='supply', targetzone='Nevatim'}),
	GroupCommander:new({name='Ramon-Supply-El Gora', mission='supply', targetzone='El Gora'}),
	GroupCommander:new({name='Ramon-Supply-SAM-Bravo', mission='supply', targetzone='SAM-Bravo'}),
	GroupCommander:new({name='Ramon-Patrol-Kedem', mission='patrol', targetzone='Kedem-Hatzerim'}),
	GroupCommander:new({name='Ramon-Patrol-Ovda', mission='attack', targetzone='Ovda'}),
	GroupCommander:new({name='Ramon-Supply-Farp-Alpha', mission='supply', targetzone='FARP-Alpha'}),
	GroupCommander:new({name='Ramon-Patrol-Kedem', mission='patrol', targetzone='Nevatim'}),
	GroupCommander:new({name='Ramon-Supply-Sam-Bravo', mission='supply', targetzone='SAM-Bravo'}),
	GroupCommander:new({name='Ramon-Attack-Melez', mission='attack', targetzone='Melez'}),
	GroupCommander:new({name='Ramon-Supply-El-Gora', mission='supply', targetzone='El Gora'}),
	GroupCommander:new({name='Ramon-Patrol-Melez', mission='patrol', targetzone='Melez'})

})
zones.ovda:addGroups({
	GroupCommander:new({name='Ovda-Attack-Kedem', mission='attack', targetzone='Ramon Airbase'}),
	GroupCommander:new({name='Ovda-Support-Ramon', mission='supply', targetzone='Ramon Airbase'}),
	GroupCommander:new({name='Ovda-Support-FARP-Alpha', mission='supply', targetzone='FARP-Alpha'}),
	GroupCommander:new({name='Ovda-Patrol-Catherine', mission='patrol', targetzone='St Catherine'}),
	GroupCommander:new({name='Ovda-Supply-Farp-Bravo', mission='supply', targetzone='FARP-Bravo'}),
	GroupCommander:new({name='Ovda-Patrol-Ramon-Airbase', mission='patrol', targetzone='Ramon Airbase'})
	
})
zones.stcatherine:addGroups({
	GroupCommander:new({name='Catherine-Attack-Ovda', mission='attack', targetzone='Ovda'}),
	GroupCommander:new({name='Catherine-Patrol-Ovda', mission='patrol', targetzone='Ovda'}),
	GroupCommander:new({name='Catherine-Supply-SAM-Charlie', mission='supply', targetzone='SAM-Charlie'}),
	GroupCommander:new({name='Catherine-Supply-FARP-Bravo', mission='supply', targetzone='FARP-Bravo'}),
	GroupCommander:new({name='Catherine-Supply-FARP-Charlie', mission='supply', targetzone='FARP-Charlie'}),
	GroupCommander:new({name='Catherine-Supply-FARP-Delta', mission='supply', targetzone='FARP-Delta'}),
	GroupCommander:new({name='Catherine-Supply-FARP-Charlie-Blue', mission='supply', targetzone='FARP-Charlie'}),
	GroupCommander:new({name='Catherine-Supply-FARP-Delta-Blue', mission='supply', targetzone='FARP-Delta'}),
	GroupCommander:new({name='Catherine-Supply-FARP-Echo-Blue', mission='supply', targetzone='FARP-Echo'}),
	GroupCommander:new({name='Catherine-Supply-FARP-Golf-Blue', mission='supply', targetzone='FARP-Golf'}),
	GroupCommander:new({name='Catherine-Supply-FARP-Foxtrot-Blue', mission='supply', targetzone='FARP-Foxtrot'}),
	GroupCommander:new({name='Catherine-Supply-FARP-Hotel-Blue', mission='supply', targetzone='FARP-Hotel'}),
	GroupCommander:new({name='Catherine-Supply-Abu-Rudeis-Blue', mission='supply', targetzone='Abu Rudeis'}),
	GroupCommander:new({name='Catherine-Supply-SAM-Charlie-Blue', mission='supply', targetzone='SAM-Charlie'})
})
zones.aburudeis:addGroups({
	GroupCommander:new({name='AbuRudis-Attack-Catherine', mission='attack', targetzone='St Catherine'}),
	GroupCommander:new({name='AbuRudis-Attack-FARP-Golf', mission='attack', targetzone='FARP-Golf'}),
	GroupCommander:new({name='AbuRudis-Attack-FARP-Hotel', mission='attack', targetzone='FARP-Hotel'}),
	GroupCommander:new({name='AbuRudis-Attack-FARP-Foxtrot', mission='attack', targetzone='FARP-Foxtrot'}),
	GroupCommander:new({name='AbuRudis-Patrol-Catherine', mission='patrol', targetzone='St Catherine'}),
	GroupCommander:new({name='AbuRudis-Support-Catherine', mission='supply', targetzone='St Catherine'}),
	GroupCommander:new({name='AbuRudis-Support-FARP-Golf', mission='supply', targetzone='FARP-Golf'}),
	GroupCommander:new({name='AbuRudis-Support-FARP-Hotel', mission='supply', targetzone='FARP-Hotel'}),
	GroupCommander:new({name='AbuRudis-Support-SAM-Delta', mission='supply', targetzone='SAM-Delta'}),
	GroupCommander:new({name='AbuRudis-Support-FARP-Foxtrot', mission='supply', targetzone='FARP-Foxtrot'}),
	GroupCommander:new({name='AbuRudeis-Supply-FARP-India', mission='supply', targetzone='FARP-India'}) -- blue
})
zones.farpmike:addGroups({
	GroupCommander:new({name='Farp-Mike-Support-FARP-Juliett', mission='supply', targetzone='FARP-Juliett'}),
	GroupCommander:new({name='Farp-Mike-Support-FARP-India', mission='supply', targetzone='FARP-India'}),
	GroupCommander:new({name='Farp-Mike-Attack-FARP-Juliett', mission='attack', targetzone='FARP-Juliett'}),
	GroupCommander:new({name='Farp-Mike-Attack-FARP-India', mission='attack', targetzone='FARP-India'}),
	GroupCommander:new({name='Farp-Mike-Support-SAM-Echo', mission='supply', targetzone='SAM-Echo'}),
	GroupCommander:new({name='Farp-Mike-Support-FARP-Juliett-Blue', mission='supply', targetzone='FARP-Juliett'}),
	GroupCommander:new({name='Farp-Mike-Support-FARP-India-Blue', mission='supply', targetzone='FARP-India'}),
	GroupCommander:new({name='Farp-Mike-Support-Kibrit-Air-Base-Blue', mission='supply', targetzone='Kibrit Air Base'}),
	GroupCommander:new({name='Farp-Mike-Support-Wadi-Al-Jandali-Blue', mission='supply', targetzone='Wadi al Jandali'})
	
})
zones.farpindia:addGroups({
	GroupCommander:new({name='FARP-India-Supply-FARP-Juliett', mission='supply', targetzone='FARP-India'})
	
})
zones.farpjuliett:addGroups({
	GroupCommander:new({name='FARP-Juliett-Supply-FARP-Mike', mission='supply', targetzone='FARP-Mike'})
	
})
zones.elarish:addGroups({
	GroupCommander:new({name='El-Arish-Patrol-Melez', mission='patrol', targetzone='Melez'}),
	GroupCommander:new({name='El-Arish-support-Farp-Lima', mission='supply', targetzone='FARP-Lima'}),
	GroupCommander:new({name='El-Arish-Supply-El-Gorah', mission='supply', targetzone='El Gora'})
})
zones.melez:addGroups({
	GroupCommander:new({name='Melez-Support-Bir Hasanah', mission='supply', targetzone='Bir Hasanah'}),
	GroupCommander:new({name='Melez-Support-FARP-Kilo', mission='supply', targetzone='FARP-Kilo'}),
	GroupCommander:new({name='Melez-Support-FARP-Lima', mission='supply', targetzone='FARP-Lima'}),
	GroupCommander:new({name='Melez-Attack-Bir Hasanah', mission='attack', targetzone='Bir Hasanah'}),
	GroupCommander:new({name='Melez-Attack-FARP-Kilo', mission='attack', targetzone='FARP-Kilo'}),
	GroupCommander:new({name='Melez-Attack-FARP-Lima', mission='attack', targetzone='FARP-Lima'}),
	GroupCommander:new({name='Melez-Patrol-Bir Hasanah', mission='patrol', targetzone='Bir Hasanah'}),
	GroupCommander:new({name='Melez-support-Bir-Hasanah-Blue', mission='supply', targetzone='Bir Hasanah'}),
	GroupCommander:new({name='Melez-support-FARP-Kilo-blue', mission='supply', targetzone='FARP-Kilo'}),
	GroupCommander:new({name='Melez-Support-Sam-Foxtrot', mission='supply', targetzone='FARP-Foxtrot', type='surface'}),
	GroupCommander:new({name='Melez-Support-Sam-Foxtrot-blue', mission='supply', targetzone='FARP-Foxtrot', type='surface'}) --blue
	
})
zones.baluza:addGroups({
	GroupCommander:new({name='Baluza-Support-SAM-Golf', mission='supply', targetzone='SAM-Golf'}),
	GroupCommander:new({name='Baluza-Support-SAM-Golf-blue', mission='supply', targetzone='SAM-Golf'}), --blue
	GroupCommander:new({name='Baluza-Support-Melez', mission='supply', targetzone='Melez'}),
	GroupCommander:new({name='Baluza-Support-FARP-Lima', mission='supply', targetzone='FARP-Lima'}),
	GroupCommander:new({name='Baluza-Attack-El Arish', mission='attack', targetzone='El Arish'}),
	GroupCommander:new({name='Baluza-Attack-Melez', mission='attack', targetzone='Melez'}),
	GroupCommander:new({name='Baluza-Support-As-Salihiyah', mission='supply', targetzone='As Salihiyah'})
})
zones.almansurah:addGroups({
	GroupCommander:new({name='Al Mansurah-Support-Al Salihiyah', mission='supply', targetzone='Al Salihiyah'}),
	GroupCommander:new({name='Al Mansurah-Support-SAM-Juliett', mission='supply', targetzone='SAM-Juliett'}),
	GroupCommander:new({name='Al Mansurah-Support-AzZaqaziq', mission='supply', targetzone='AzZaqaziq'}),
	GroupCommander:new({name='Al Mansurah-Support-SAM-Juliett-blue', mission='supply', targetzone='SAM-Juliett'}) --Blue
})
zones.azzaqaziq:addGroups({
	GroupCommander:new({name='AzZaqaziq-Patrol-Red Carrier', mission='patrol', targetzone='Red Carrier'}),
	GroupCommander:new({name='AzZaqaziq-Support-As Salihiyah', mission='supply', targetzone='As Salihiyah'}),
	GroupCommander:new({name='AzZaqaziq-Support-Abu Suwayr', mission='supply', targetzone='Abu Suwayr'}),
	GroupCommander:new({name='AzZaqaziq-Support-Fayed', mission='supply', targetzone='Fayed'}),
	GroupCommander:new({name='AzZaqaziq-Support-Kibrit', mission='supply', targetzone='Kibrit Air Base'}),
	GroupCommander:new({name='AzZaqaziq-Attack-As Salihiyah', mission='attack', targetzone='As Salihiyah'}),
	GroupCommander:new({name='AzZaqaziq-Attack-Abu Suwayr', mission='attack', targetzone='Abu Suwayr'}),
	GroupCommander:new({name='AzZaqaziq-Attack-Fayed', mission='attack', targetzone='Fayed'}),
	GroupCommander:new({name='AzZaqaziq-Supply-Al-Mansurah', mission='supply', targetzone='Al Mansurah'}),
	GroupCommander:new({name='AzZaqaziq-Supply-FARP-November', mission='supply', targetzone='FARP-November'}),
	GroupCommander:new({name='AzZaqaziq-Supply-Bilbeis-air-base', mission='supply', targetzone='Bilbeis air base'}),
	GroupCommander:new({name='AzZaqaziq-attack-Melez', mission='attack', targetzone='Melez'})

	
})
zones.wadialjandali:addGroups({
	GroupCommander:new({name='Wadi-Attack-Ramon', mission='patrol', targetzone='Melez'}),
	GroupCommander:new({name='Wadi-Attack-Catherine', mission='patrol', targetzone='Abu Rudeis'}),
	GroupCommander:new({name='Wadi-Attack-FARP-Mike', mission='attack', targetzone='FARP-Mike', type='surface'}),
	GroupCommander:new({name='Wadi-Support-FARP-Mike', mission='supply', targetzone='FARP-Mike', type='surface'}),
	GroupCommander:new({name='Wadi-Attack-Baluza', mission='attack', targetzone='Baluza'}),
	GroupCommander:new({name='Wadi-Patrol-Melez', mission='patrol', targetzone='Melez'}),
	GroupCommander:new({name='Wadi-patrol-Patrol-Abu-Rudeis', mission='patrol', targetzone='Abu-Rudeis'}),
	GroupCommander:new({name='Wadi-al-jandali-support-Sam-India-blue', mission='supply', targetzone='SAM-India', type='surface'}),
	GroupCommander:new({name='Wadi-al-jandali-support-Sam-India-red', mission='supply', targetzone='SAM-India', type='surface'}),
	GroupCommander:new({name='Wadi-Support-Cairo-International-Airport', mission='supply', targetzone='Cairo International Airport'}),
	GroupCommander:new({name='Wadi-Support-Bilbeis-Air-Base', mission='supply', targetzone='Bilbeis Air Base'}),
	GroupCommander:new({name='Wadi-Attack-Melez-and-kibrit', mission='attack', targetzone='Melez'})
	
})
zones.fayed:addGroups({
	GroupCommander:new({name='Fayed-Support-Wadi-Al-Jandali-Blue', mission='supply', targetzone='Wadi al Jandali'}),
	GroupCommander:new({name='Fayed-Support-abu-Suwayr', mission='supply', targetzone='Abu Suwayr'})
		
})

zones.abusuwayr:addGroups({
	
	GroupCommander:new({name='Abu-Suway-Support-Azzaqaziq', mission='supply', targetzone='AzZaqaziq'})
		
})


zones.assalihiyah:addGroups({
	GroupCommander:new({name='As-Salihiyah-Support-SAM-Hotel-red', mission='supply', targetzone='SAM-Hotel', type='surface'}), -- red
	GroupCommander:new({name='As-Salihiyah-Support-SAM-Hotel-blue', mission='supply', targetzone='SAM-Hotel', type='surface'}) -- blue
		
})
zones.kibritairbase:addGroups({
	GroupCommander:new({name='Kibrit-Air-Base-Support-Fayed-Blue', mission='supply', targetzone='Fayed'}),
	GroupCommander:new({name='Kibrit Air Base-supply-Farp-Mike', mission='supply', targetzone='FARP-Mike'})
	
})

zones.bilbeisairbase:addGroups({
	GroupCommander:new({name='bilbeis-Airbase-patrol-Abu-Suwayr', mission='patrol', targetzone='Abu Suwayr'}),
	GroupCommander:new({name='bilbeis-Airbase-patrol-SAM-Juliett', mission='patrol', targetzone='SAM-Juliett'}),
	GroupCommander:new({name='bilbeis-AirBase-Support-Cairo-West', mission='supply', targetzone='Cairo West'})
	
})


zones.cairowest:addGroups({
	GroupCommander:new({name='CairoWest-Support-Nevrim', mission='supply', targetzone='Nevatim'}),
	GroupCommander:new({name='CairoWest-Support-Melez', mission='supply', targetzone='Melez'}),
	GroupCommander:new({name='CairoWest-Patrol-Wadi', mission='patrol', targetzone='Wadi al Jandali'}),
	GroupCommander:new({name='CairoWest-Patrol-AzZaqaziq', mission='patrol', targetzone='AzZaqaziq'}),
	GroupCommander:new({name='CairoWest-Support-Wadi', mission='supply', targetzone='Wadi al Jandali'}),
	GroupCommander:new({name='CairoWest-Patrol-Cario-West', mission='patrol', targetzone='Cairo West'}),
	GroupCommander:new({name='CairoWest-Support-FARP-November', mission='supply', targetzone='FARP-November'})
})

for i,v in pairs(zones) do
	bc:addZone(v)
end


bc:addConnection("Blue Carrier","Ben-Gurion")
bc:addConnection("Ben-Gurion","Tel Nof")
bc:addConnection("Tel Nof","Kedem-Hatzerim")
bc:addConnection("Kedem-Hatzerim","Nevatim")
bc:addConnection("Kedem-Hatzerim","Ramon Airbase")
bc:addConnection("Kedem-Hatzerim","El Gora")
bc:addConnection("El Gora","El Arish")
bc:addConnection("El Arish","FARP-Kilo")
bc:addConnection("El Arish","FARP-Lima")
bc:addConnection("Ramon Airbase","FARP-Alpha")
bc:addConnection("Ramon Airbase","Nevatim")
bc:addConnection("Ramon Airbase","El Gora")
bc:addConnection("FARP-Alpha","Ovda")
bc:addConnection("Ovda","FARP-Bravo")
bc:addConnection("FARP-Bravo","FARP-Charlie")
bc:addConnection("FARP-Charlie","FARP-Delta")
bc:addConnection("FARP-Charlie","St Catherine")
bc:addConnection("St Catherine","FARP-Delta")
bc:addConnection("St Catherine","FARP-Echo")
bc:addConnection("St Catherine","FARP-Golf")
bc:addConnection("St Catherine","Abu Rudeis")
bc:addConnection("FARP-Delta","FARP-Echo")
bc:addConnection("FARP-Echo","FARP-Foxtrot")
bc:addConnection("FARP-Golf","FARP-Foxtrot")
bc:addConnection("FARP-Golf","FARP-Hotel")
bc:addConnection("FARP-Hotel","Abu Rudeis")
bc:addConnection("Abu Rudeis","FARP-India")
bc:addConnection("FARP-India","FARP-Juliett")
bc:addConnection("FARP-Juliett","FARP-Mike")
bc:addConnection("FARP-Mike","Kibrit Air Base")
bc:addConnection("FARP-Mike","Wadi al Jandali")
bc:addConnection("FARP-Alpha","FARP-Kilo")
bc:addConnection("FARP-Kilo","Bir Hasanah")
bc:addConnection("Bir Hasanah","Melez")
bc:addConnection("Melez","FARP-Lima")
bc:addConnection("FARP-Lima","Baluza")
bc:addConnection("Baluza","As Salihiyah")

bc:addConnection("As Salihiyah","Abu Suwayr")
bc:addConnection("As Salihiyah","AzZaqaziq")
bc:addConnection("As Salihiyah","Al Mansurah")
bc:addConnection("Fayed","Kibrit Air Base")
bc:addConnection("Kibrit Air Base","Melez")
bc:addConnection("Fayed","Wadi al Jandali")
bc:addConnection("Fayed","Abu Suwayr")

bc:addConnection("Al Mansurah","AzZaqaziq")
bc:addConnection("Al Mansurah","FARP-November")
bc:addConnection("AzZaqaziq","Bilbeis Air Base")
bc:addConnection("Bilbeis Air Base","FARP-November")
bc:addConnection("Cairo International Airport","Wadi al Jandali")
bc:addConnection("Cairo West","FARP-November")
bc:addConnection("Cairo West","Cairo International Airport")



bc:addConnection("Tel Nof","SAM-Alpha")
bc:addConnection("Ramon Airbase","SAM-Bravo")
bc:addConnection("St Catherine","SAM-Charlie")
bc:addConnection("FARP-Golf","SAM-Delta")
bc:addConnection("Bir Hasanah","SAM-Echo")
bc:addConnection("Melez","SAM-Foxtrot")
bc:addConnection("Baluza","SAM-Golf")
bc:addConnection("As Salihiyah","SAM-Hotel")
bc:addConnection("Al Mansurah","SAM-Juliett")
bc:addConnection("Wadi al Jandali","SAM-India")
bc:addConnection("Wadi al Jandali","Bilbeis Air Base")

local checkMissionComplete = function (event, sender)
	local done = true
	for i,v in ipairs(bc:getZones()) do
		if v.side == 1 then
			done = false
			break
		end
	end
	
	if done then
		trigger.action.outText("Enemy has been defeated. \n\nMission Complete.", 120)
	end
end

for i,v in ipairs(bc:getZones()) do
	v:registerTrigger('lost', checkMissionComplete, 'missioncompleted')
end


local upgradeMenu = nil
bc:registerShopItem('supplies', 'Resupply or upgrade friendly Zone', 149, function(sender)
	if upgradeMenu then
		return 'Choose zone from F10 menu'
	end
	
	local upgradeZone = function(target)
		if upgradeMenu then
			local zn = bc:getZoneByName(target)
			if zn and zn.side==2 then
				zn:upgrade()
			else
				return 'Zone not friendly'
			end
			
			upgradeMenu = nil
		end
	end
	
	upgradeMenu = bc:showTargetZoneMenu(2, 'Select Zone to resupply or upgrade', upgradeZone, 2)
	
	trigger.action.outTextForCoalition(2, 'Supplies prepared. Choose zone from F10 menu', 15)
end,
function(sender, params)
	if params.zone and params.zone.side == 2 then
		params.zone:upgrade()
	else
		return 'Can only target friendly zone'
	end
end)

Group.getByName('f16cap1'):destroy()
Group.getByName('f16cap2'):destroy()
Group.getByName('f16cap3'):destroy()
Group.getByName('f16cap4'):destroy()
Group.getByName('f16cap5'):destroy()

bc:registerShopItem('cap', 'CAP ', 300, 
    function(sender)
        local grname = 'f16cap1'
        if (zones.ramonairbase.side == 2 and zones.kedemhatzerim.side == 2 and zones.ovda.side == 1) then
        grname = 'f16cap2'
    elseif (zones.birhasanah.side == 1 and zones.ovda.side == 2 and zones.stcatherine.side == 2) then
        grname = 'f16cap3'
	elseif (zones.birhasanah.side == 2 and zones.samfoxtrot.side == 2 and zones.azzaqaziq.side == 1) then
        grname = 'f16cap4'
	elseif (zones.azzaqaziq.side == 2 and zones.samhotel.side == 2 and zones.abusuwayr.side == 2) then
        grname = 'f16cap5'
    
    end

        local gr = Group.getByName(grname)
        if Utils.isGroupActive(gr) then
            return 'CAP mission still in progress'
        end

        mist.respawnGroup(grname, true)
    end, 
    function(sender, params)
        local grname = 'f16cap1'
        if (zones.ramonairbase.side == 2 and zones.kedemhatzerim.side == 2 and zones.ovda.side == 1) then
        grname = 'f16cap2'
    elseif (zones.birhasanah.side == 1 and zones.ovda.side == 2 and zones.stcatherine.side == 2) then
        grname = 'f16cap3'
	elseif (zones.birhasanah.side == 2 and zones.samfoxtrot.side == 2 and zones.azzaqaziq.side == 1) then
        grname = 'f16cap4'
	elseif (zones.azzaqaziq.side == 2 and zones.samhotel.side == 2 and zones.abusuwayr.side == 2) then
        grname = 'f16cap5'
    end

        local gr = Group.getByName(grname)
        if Utils.isGroupActive(gr) then
            return 'CAP mission still in progress'
        end

        mist.respawnGroup(grname, true)
    end
) -- close the registerShopItem function
-- End of script

tanksMenu = nil
bc:registerShopItem('armor', 'Deploy armor (for combined arms) ', 300, function(sender)
	
	if tanksMenu then
		return 'Choose deploy zone from F10 menu'
	end
	
	local deployTanks = function(target)
		if tanksMenu then
		
			local zn = CustomZone:getByName(target)
			zn:spawnGroup('ca-tanks')
			
			tanksMenu = nil
			trigger.action.outTextForCoalition(2, 'Friendly armor deployed at '..target, 15)
		end
	end
	
	tanksMenu = bc:showTargetZoneMenu(2, 'Deploy armor (Choose friendly zone) ', deployTanks, 2)
	trigger.action.outTextForCoalition(2, 'Choose deploy zone from F10 menu', 15)
end,
function(sender, params)
	if params.zone and params.zone.side == 2 then
		
		local zn = CustomZone:getByName(params.zone.zone)
		zn:spawnGroup('ca-tanks')
		trigger.action.outTextForCoalition(2, 'Friendly armor deployed at '..params.zone.zone, 15)
	else
		return 'Can only deploy at friendly zone'
	end
end)

artyMenu = nil
bc:registerShopItem('artillery', 'Deploy artillery (for combined arms) ', 200, function(sender)
	
	if artyMenu then
		return 'Choose deploy zone from F10 menu'
	end
	
	local deployArty = function(target)
		if artyMenu then
		
			local zn = CustomZone:getByName(target)
			zn:spawnGroup('ca-arty')
			
			artyMenu = nil
			trigger.action.outTextForCoalition(2, 'Friendly artillery deployed at '..target, 15)
		end
	end
	
	artyMenu = bc:showTargetZoneMenu(2, 'Deploy artillery (Choose friendly zone) ', deployArty, 2)
	trigger.action.outTextForCoalition(2, 'Choose deploy zone from F10 menu ', 15)
end,
function(sender, params)
	if params.zone and params.zone.side == 2 then
		
		local zn = CustomZone:getByName(params.zone.zone)
		zn:spawnGroup('ca-arty')
		trigger.action.outTextForCoalition(2, 'Friendly artillery deployed at '..params.zone.zone, 15)
	else
		return 'Can only deploy at friendly zone'
	end
end)

reconMenu = nil
bc:registerShopItem('recon', 'Deploy recon group (for combined arms)', 50, function(sender)
	
	if reconMenu then
		return 'Choose deploy zone from F10 menu'
	end
	
	local deployRecon = function(target)
		if reconMenu then
		
			local zn = CustomZone:getByName(target)
			zn:spawnGroup('ca-recon')
			
			reconMenu = nil
			trigger.action.outTextForCoalition(2, 'Friendly recon group deployed at '..target, 15)
		end
	end
	
	reconMenu = bc:showTargetZoneMenu(2, 'Deploy recon group (Choose friendly zone)', deployRecon, 2)
	trigger.action.outTextForCoalition(2, 'Choose deploy zone from F10 menu', 15)
end,
function(sender, params)
	if params.zone and params.zone.side == 2 then
		
		local zn = CustomZone:getByName(params.zone.zone)
		zn:spawnGroup('ca-recon')
		trigger.action.outTextForCoalition(2, 'Friendly recon group deployed at '..params.zone.zone, 15)
	else
		return 'Can only deploy at friendly zone'
	end
end)

airdefMenu = nil
bc:registerShopItem('airdef', 'Deploy air defence (for combined arms)', 150, function(sender)
	
	if airdefMenu then
		return 'Choose deploy zone from F10 menu'
	end
	
	local deployAirDef = function(target)
		if airdefMenu then
		
			local zn = CustomZone:getByName(target)
			zn:spawnGroup('ca-airdef')
			
			airdefMenu = nil
			trigger.action.outTextForCoalition(2, 'Friendly air defence deployed at '..target, 15)
		end
	end
	
	airdefMenu = bc:showTargetZoneMenu(2, 'Deploy air defence (Choose friendly zone)', deployAirDef, 2)
	trigger.action.outTextForCoalition(2, 'Choose deploy zone from F10 menu', 15)
end,
function(sender, params)
	if params.zone and params.zone.side == 2 then
		
		local zn = CustomZone:getByName(params.zone.zone)
		zn:spawnGroup('ca-airdef')
		trigger.action.outTextForCoalition(2, 'Friendly air defence deployed at '..params.zone.zone, 15)
	else
		return 'Can only deploy at friendly zone'
	end
end)


Group.getByName('jtacDrone'):destroy()
local jtacTargetMenu = nil
drone = JTAC:new({name = 'jtacDrone'})
bc:registerShopItem('jtac', 'MQ-9 Reaper JTAC mission ', 300, function(sender)
	
	if jtacTargetMenu then
		return 'Choose target zone from F10 menu'
	end
	
	local spawnAndOrbit = function(target)
		if jtacTargetMenu then
			local zn = bc:getZoneByName(target)
			drone:deployAtZone(zn)
			drone:showMenu()
			trigger.action.outTextForCoalition(2, 'Reaper drone deployed over '..target, 15)
			jtacTargetMenu = nil
		end
	end
	
	jtacTargetMenu = bc:showTargetZoneMenu(2, 'Deploy JTAC ', spawnAndOrbit, 1)
	
	trigger.action.outTextForCoalition(2, 'Choose which zone to deploy JTAC at from F10 menu', 15)
end,
function(sender, params)
	if params.zone and params.zone.side == 1 then
		drone:deployAtZone(params.zone)
		drone:showMenu()
		trigger.action.outTextForCoalition(2, 'Reaper drone deployed over '..params.zone.zone, 15)
	else
		return 'Can only target enemy zone'
	end
end)

local smoketargets = function(tz)
	local units = {}
	for i,v in pairs(tz.built) do
		local g = Group.getByName(v)
		for i2,v2 in ipairs(g:getUnits()) do
			table.insert(units, v2)
		end
	end
	
	local tgts = {}
	for i=1,3,1 do
		if #units > 0 then
			local selected = math.random(1,#units)
			table.insert(tgts, units[selected])
			table.remove(units, selected)
		end
	end
	
	for i,v in ipairs(tgts) do
		local pos = v:getPosition().p
		trigger.action.smoke(pos, 1)
	end
end

local smokeTargetMenu = nil
bc:registerShopItem('smoke', 'Smoke markers ', 20, function(sender)
	if smokeTargetMenu then
		return 'Choose target zone from F10 menu'
	end
	
	local launchAttack = function(target)
		if smokeTargetMenu then
			local tz = bc:getZoneByName(target)
			smoketargets(tz)
			smokeTargetMenu = nil
			trigger.action.outTextForCoalition(2, 'Targets marked with RED smoke at '..target, 15)
		end
	end
	
	smokeTargetMenu = bc:showTargetZoneMenu(2, 'Smoke marker target', launchAttack, 1)
	
	trigger.action.outTextForCoalition(2, 'Choose target zone from F10 menu ', 15)
end,
function(sender, params)
	if params.zone and params.zone.side == 1 then
		smoketargets(params.zone)
		trigger.action.outTextForCoalition(2, 'Targets marked with RED smoke at '..params.zone.zone, 15)
	else
		return 'Can only target enemy zone'
	end
end)

local casTargetMenu = nil
Group.getByName('cas1'):destroy()
Group.getByName('cas2'):destroy()
Group.getByName('cas3'):destroy()
Group.getByName('cas4'):destroy()
Group.getByName('cas5'):destroy()
bc:registerShopItem('cas', 'F-16C Ground Attack ', 400, function(sender)
    local grname = 'cas1'
        if (zones.ramonairbase.side == 2 and zones.kedemhatzerim.side == 2 and zones.ovda.side == 1) then
        grname = 'cas2'
		elseif (zones.birhasanah.side == 1 and zones.ovda.side == 2 and zones.stcatherine.side == 2) then
        grname = 'cas3'
		elseif (zones.birhasanah.side == 2 and zones.samfoxtrot.side == 2 and zones.azzaqaziq.side == 1) then
        grname = 'cas4'
		elseif (zones.azzaqaziq.side == 2 and zones.samhotel.side == 2 and zones.abusuwayr.side == 2) then
        grname = 'cas5'
    end

    local gr = Group.getByName(grname)
    if Utils.isGroupActive(gr) then
        return 'Ground attack mission still in progress'
    end

    mist.respawnGroup(grname, true)

    if casTargetMenu then
        return 'Choose target zone from F10 menu'
    end

    local launchAttack = function(target)
        if casTargetMenu then
            if Group.getByName(grname) then
                local err = bc:engageZone(target, grname)
                if err then
                    return err
                end

                trigger.action.outTextForCoalition(2, 'F-16C engaging groups at ' .. target, 15)
            else
                trigger.action.outTextForCoalition(2, 'Group has left the area or has been destroyed', 15)
            end

            casTargetMenu = nil
        end
    end

    casTargetMenu = bc:showTargetZoneMenu(2, 'F-16C Target', launchAttack, 1)

    trigger.action.outTextForCoalition(2, 'F-16C on route. Choose target zone from F10 menu for ' .. grname, 15)
end,
function(sender, params)
    if params.zone and params.zone.side == 1 then
        local grname = 'cas1'
        if (zones.ramonairbase.side == 2 and zones.kedemhatzerim.side == 2 and zones.ovda.side == 1) then
        grname = 'cas2'
		elseif (zones.birhasanah.side == 1 and zones.ovda.side == 2 and zones.stcatherine.side == 2) then
        grname = 'cas3'
		elseif (zones.birhasanah.side == 2 and zones.samfoxtrot.side == 2 and zones.azzaqaziq.side == 1) then
        grname = 'cas4'
		elseif (zones.azzaqaziq.side == 2 and zones.samhotel.side == 2 and zones.abusuwayr.side == 2) then
        grname = 'cas5'
    end

        local gr = Group.getByName(grname)
        if gr and gr:getSize() > 0 and gr:getController():hasTask() then
            return 'Ground attack mission still in progress'
        end

        mist.respawnGroup(grname, true)
        mist.scheduleFunction(function(target)
            if Group.getByName(grname) then
                local err = bc:engageZone(target, grname)
                if err then
                    return err
                end

                trigger.action.outTextForCoalition(2, 'F-16C engaging groups at ' .. target, 15)
            end
        end, {params.zone.zone}, timer.getTime() + 2)
    else
        return 'Can only target enemy zone'
    end
end)

local seadTargetMenu = nil
Group.getByName('sead1'):destroy()
Group.getByName('sead2'):destroy()
Group.getByName('sead3'):destroy()
Group.getByName('sead4'):destroy()
Group.getByName('sead5'):destroy()

bc:registerShopItem('sead', 'F-16C SEAD mission ', 500, function(sender)
		local grname = 'sead1'
        if (zones.ramonairbase.side == 2 and zones.kedemhatzerim.side == 2 and zones.ovda.side == 1) then
        grname = 'sead2'
    elseif (zones.birhasanah.side == 1 and zones.ovda.side == 2 and zones.stcatherine.side == 2) then
        grname = 'sead3'
	elseif (zones.birhasanah.side == 2 and zones.samfoxtrot.side == 2 and zones.azzaqaziq.side == 1) then
        grname = 'sead4'
	elseif (zones.azzaqaziq.side == 2 and zones.samhotel.side == 2 and zones.abusuwayr.side == 2) then
        grname = 'sead5'
    end

    local gr = Group.getByName(grname)
    if Utils.isGroupActive(gr) then
        return 'SEAD mission still in progress'
    end

    mist.respawnGroup(grname, true)

    if seadTargetMenu then
        return 'Choose target zone from F10 menu'
    end

    local launchAttack = function(target)
        if seadTargetMenu then
            if Group.getByName(grname) then
                local err = bc:engageZone(target, grname)
                if err then
                    return err
                end

                trigger.action.outTextForCoalition(2, 'F-16C Vipers engaging SAMs at ' .. target, 15)
            else
                trigger.action.outTextForCoalition(2, 'Group has left the area or has been destroyed', 15)
            end

            seadTargetMenu = nil
        end
    end

    seadTargetMenu = bc:showTargetZoneMenu(2, 'SEAD Target', launchAttack, 1)

    trigger.action.outTextForCoalition(2, 'F-16C Vipers on route. Choose target zone from F10 menu for ' .. grname, 15)
end,
	function(sender, params)
    if params.zone and params.zone.side == 1 then
        local grname = 'sead1'
        if (zones.ramonairbase.side == 2 and zones.kedemhatzerim.side == 2 and zones.ovda.side == 1) then
        grname = 'sead2'
		elseif (zones.birhasanah.side == 1 and zones.ovda.side == 2 and zones.stcatherine.side == 2) then
        grname = 'sead3'
		elseif (zones.birhasanah.side == 2 and zones.samfoxtrot.side == 2 and zones.azzaqaziq.side == 1) then
        grname = 'sead4'
		elseif (zones.azzaqaziq.side == 2 and zones.samhotel.side == 2 and zones.abusuwayr.side == 2) then
        grname = 'sead5'
    end

        local gr = Group.getByName(grname)
        if gr and gr:getSize() > 0 and gr:getController():hasTask() then
            return 'SEAD mission still in progress'
        end

        mist.respawnGroup(grname, true)
        mist.scheduleFunction(function(target)
            if Group.getByName(grname) then
                local err = bc:engageZone(target, grname)
                if err then
                    return err
                end

                trigger.action.outTextForCoalition(2, 'F-16C Vipers engaging SAMs at ' .. target, 15)
            end
        end, {params.zone.zone}, timer.getTime() + 2)
    else
        return 'Can only target enemy zone'
    end
end)



bc:addShopItem(2, 'cap', -1)
bc:addShopItem(2, 'cas', -1)
bc:addShopItem(2, 'sead', -1)
bc:addShopItem(2, 'supplies', -1)
bc:addShopItem(2, 'jtac', -1)
--bc:addShopItem(2, 'smoke', -1)
bc:addShopItem(2, 'armor', -1)
bc:addShopItem(2, 'artillery', -1)
bc:addShopItem(2, 'recon', -1)
bc:addShopItem(2, 'airdef', -1)


supplyZones = {
	'Blue Carrier',
	'Ben-Gurion',
	'Tel Nof', 
	'Kedem-Hatzerim', 
	'Nevatim', 
	'Ramon Airbase',
	'El Gora',
	'El Arish',
	'Ovda',
	'St Catherine',
	'Abu Rudeis',
	'Bir Hasanah',
	'Melez',
	'Baluza',
	'Al Mansurah',
	'As Salihiyah',
	'Abu Suwayr',
	'AzZaqaziq',
	'Fayed',
	'Kibrit Air Base',
	'Bilbeis Air Base',
	'Cairo International Airbport',
	'Wadi al Jandali',
	'Cairo West',
	
	'FARP-Alpha',
	'FARP-Bravo',
	'FARP-Charlie',
	'FARP-Delta',
	'FARP-Echo',
	'FARP-Foxtrot',
	'FARP-Golf',
	'FARP-Hotel',
	'FARP-India',
	'FARP-Juliett',
	'FARP-Kilo',
	'FARP-Lima',
	'FARP-Mike',
	'FARP-November'
}

lc = LogisticCommander:new({battleCommander = bc, supplyZones = supplyZones})
lc:init()

bc:loadFromDisk() --will load and overwrite default zone levels, sides, funds and available shop items
bc:init()
bc:startRewardPlayerContribution(15,{infantry = 10, ground = 20, sam = 40, airplane = 50, ship = 250, helicopter=50, crate=200, rescue = 100})
HercCargoDropSupply.init(bc)

GlobalSettings.defaultRespawns[1]['supply'] = { dead=60*60, hangar=30*60, preparing=5*60}
GlobalSettings.setDifficultyScaling(1.4,1)


evc = EventCommander:new({ decissionFrequency=30*60, decissionVariance=30*60, skipChance = 10})
evc:init()


Group.getByName('evt-shiptercept1'):destroy()
Group.getByName('evt-shiptercept2'):destroy()
Group.getByName('evt-shiptercept3'):destroy()
local shipDieEvent = nil
evc:addEvent({
	id='shiptercept',
	action = function()
	
		local ships = {'evt-shiptercept1','evt-shiptercept2','evt-shiptercept3'}
		local choice = math.random(1,#ships)
		
		mist.respawnGroup(ships[choice], true)
		
		local shipDied = function(event)
			if event.id==30 then
				if event.initiator and event.initiator.getName then
					local name = event.initiator:getName()
					if type(name)=="string" and name:find('^evt%-shiptercept') then
						mist.removeEventHandler(shipDieEvent)
						shipDieEvent = nil
						trigger.action.outTextForCoalition(2,'Enemy supply ship destroyed.\n+500 credits',15)
						bc:addFunds(2,500)
					end
				end
			end
		end
		shipDieEvent = mist.addEventHandler(shipDied)
	end,
	canExecute = function()
		if math.random(1,100) < 70 then return false end
		
		if Group.getByName('evt-shiptercept1') then return false end
		if Group.getByName('evt-shiptercept2') then return false end
		if Group.getByName('evt-shiptercept3') then return false end
		
		return true
	end
})

Group.getByName('evt-cargointercept1'):destroy()
Group.getByName('evt-cargointercept2'):destroy()
Group.getByName('evt-cargointercept3'):destroy()
local cargoDieEvent = nil
evc:addEvent({
	id='cargointercept',
	action = function()
	
		local planes = {'evt-cargointercept1','evt-cargointercept2','evt-cargointercept3'}
		local choice = math.random(1,#planes)
		
		mist.respawnGroup(planes[choice], true)
		
		local cargoDie = function(event)
			if event.id==30 then
				if event.initiator and event.initiator.getName then
					local name = event.initiator:getName()
					if type(name)=="string" and name:find('^evt%-cargointercept') then
						mist.removeEventHandler(cargoDieEvent)
						cargoDieEvent = nil
						trigger.action.outTextForCoalition(2,'Enemy cargo plane destroyed.\n+500 credits',15)
						bc:addFunds(2,500)
					end
				end
			end
		end
		cargoDieEvent = mist.addEventHandler(cargoDie)
	end,
	canExecute = function()
		if math.random(1,100) < 70 then return false end
		
		if bc:getZoneByName('FARP-November').side ~= 1 then return false end
		if bc:getZoneByName('Cairo West').side ~= 1 then return false end
		
		if Group.getByName('evt-cargointercept1') then return false end
		if Group.getByName('evt-cargointercept2') then return false end
		if Group.getByName('evt-cargointercept3') then return false end
		
		return true
	end
})

mc = MissionCommander:new({side = 2, battleCommander = bc, checkFrequency = 60})

mc:trackMission({
	title = "Intercept cargo plane",
	description = "Find and destroy the enemy cargo plane taking and destroy it.",
	messageStart = "New mission: Intercept cargo plane",
	messageEnd = "Mission ended: Intercept cargo plane",
	startAction = function() trigger.action.outSoundForCoalition(2,"radio1.ogg") end,
	endAction = function() trigger.action.outSoundForCoalition(2,"cancel.ogg") end,
	isActive = function()
		if Group.getByName('evt-cargointercept1') then return true end
		if Group.getByName('evt-cargointercept2') then return true end
		if Group.getByName('evt-cargointercept3') then return true end
		
		return false
	end
})

mc:trackMission({
	title = "Destroy cargo & battle ships",
	description = "Find and destroy the enemy cargo & battle ships sailing and destroy it.!",
	messageStart = "New mission: Destroy cargo & battle ships",
	messageEnd = "Mission ended: Destroy cargo & battle ships",
	startAction = function() trigger.action.outSoundForCoalition(2,"radio2.ogg") end,
	endAction = function() trigger.action.outSoundForCoalition(2,"cancel.ogg") end,
	isActive = function()
		if Group.getByName('evt-shiptercept1') then return true end
		if Group.getByName('evt-shiptercept2') then return true end
		if Group.getByName('evt-shiptercept3') then return true end
		
		return false
	end
})

resupplyTarget = nil
mc:trackMission({
	title = function() return "Resupply "..resupplyTarget end,
	description = function() return "Deliver supplies to "..resupplyTarget end,
	messageStart = function() return "New mission: Resupply "..resupplyTarget end,
	messageEnd = function() return "Mission ended: Resupply "..resupplyTarget end,
	startAction = function() trigger.action.outSoundForCoalition(2,"ding.ogg") end,
	endAction = function() 
		resupplyTarget = nil
		trigger.action.outSoundForCoalition(2,"cancel.ogg")
	end,
	isActive = function()
		if not resupplyTarget then return false end
		
		local targetzn = bc:getZoneByName(resupplyTarget)
		return targetzn:canRecieveSupply()
	end
})

attackTarget = nil
mc:trackMission({
	title = function() return "Attack "..attackTarget end,
	description = function() return "Destroy enemy forces at "..attackTarget end,
	messageStart = function() return "New mission: Attack "..attackTarget end,
	messageEnd = function() return "Mission ended: Attack "..attackTarget end,
	startAction = function() trigger.action.outSoundForCoalition(2,"cas.ogg") end,
	endAction = function() 
		attackTarget = nil 
		trigger.action.outSoundForCoalition(2,"cancel.ogg")
	end,
	isActive = function()
		if not attackTarget then return false end
		
		local targetzn = bc:getZoneByName(attackTarget)
		return targetzn.side == 1
	end
})

captureTarget = nil
mc:trackMission({
	title = function() return "Capture "..captureTarget end,
	description = function() return captureTarget.." is neutral. Capture it by delivering supplies" end,
	messageStart = function() return "New mission: Capture "..captureTarget end,
	messageEnd = function() return "Mission ended: Capture "..captureTarget end,
	startAction = function() trigger.action.outSoundForCoalition(2,"ding.ogg") end,
	endAction = function() 
		captureTarget = nil 
		trigger.action.outSoundForCoalition(2,"cancel.ogg")
	end,
	isActive = function()
		if not captureTarget then return false end
		
		local targetzn = bc:getZoneByName(captureTarget)
		return targetzn.side == 0 and targetzn.active
	end
})

function generateCaptureMission()
	if captureTarget ~= nil then return end
		
	local validzones = {}
	for _,v in ipairs(bc.zones) do
		if v.side == 0 and v.active then
			table.insert(validzones, v.zone)
		end
	end
	
	if #validzones == 0 then return end
	
	local choice = math.random(1, #validzones)
	if validzones[choice] then
		captureTarget = validzones[choice]
		return true
	end
end

function generateAttackMission()
	if attackTarget ~= nil then return end
		
	local validzones = {}
	for _,v in ipairs(bc.connections) do
		local to = bc:getZoneByName(v.to)
		local from = bc:getZoneByName(v.from)
		
		if from.side ~= to.side and from.side ~= 0  and to.side ~= 0 and from.active and to.active then
			if from.side == 1 then
				table.insert(validzones, from.zone)
			elseif to.side == 1 then
				table.insert(validzones, to.zone)
			end
		end
	end
	
	if #validzones == 0 then return end
	
	local choice = math.random(1, #validzones)
	if validzones[choice] then
		attackTarget = validzones[choice]
		return true
	end
end

function generateSupplyMission()
	if resupplyTarget ~= nil then return end
		
	local validzones = {}
	for _,v in ipairs(bc.zones) do
		if v.side == 2 and v:canRecieveSupply() then
			table.insert(validzones, v.zone)
		end
	end
	
	if #validzones == 0 then return end
	
	local choice = math.random(1, #validzones)
	if validzones[choice] then
		resupplyTarget = validzones[choice]
		return true
	end
end

timer.scheduleFunction(function(_, time)
	if generateCaptureMission() then
		return time+300
	else
		return time+120
	end
end, {}, timer.getTime() + 20)

timer.scheduleFunction(function(_, time)
	if generateAttackMission() then
		return time+300
	else
		return time+120
	end
end, {}, timer.getTime() + 40)

timer.scheduleFunction(function(_, time)
	if generateSupplyMission() then
		return time+300
	else
		return time+120
	end
end, {}, timer.getTime() + 60)

mc:init()

env.info("Mission Setup : is completed!")