env.info("ZEUS START: is loading.")

SupportHandler = EVENTHANDLER:New()

function randomnumberZEUS()
	local rngz = math.random(1,1000)
	return rngz
end

function spv(groupName, coord)
  local RngNumZEUS = randomnumberZEUS()
	group = SPAWN:NewWithAlias(groupName, groupName .. RngNumZEUS)
    --:InitRepeatOnLanding()
	group:SpawnFromVec2(coord:GetVec2())
end

function handleSpawnRequest(text, coord)
    local unitList = {
		--red      
	    "SA-8",
        "SA-9",
        "SA-13",
        "SA-15",
        "SA-19",
        "Soldier",
        "Truck",
        "Shilka",
        "Igla",
        "Igla-S",
		"RPG",
		"BMP2",
		"Tank",
		"BTR80",
        --blue
        "JTAC9lineam",
		"JTAC9linefm",
    }
    
    for i_unit = 1, #unitList do
        if text == "-create " .. unitList[i_unit]:lower() then
			spv(unitList[i_unit], coord)
			trigger.action.outText( "" .. unitList[i_unit] .. " on your MAP MARKER succesfully CREATED.", 10)
			--trigger.action.outSound( "BD_00007 single beep.ogg")
			env.info("" .. unitList[i_unit] .. " on your MAP MARKER succesfully CREATED.")
		end
	end   
end

function handleDebugRequest(text, coord)

end

local destroyZoneCount = 0
function handleDestroyRequest(text, coord)
    local destroyZoneName = string.format("destroy %d", destroyZoneCount)
    local zoneRadiusToDestroy = ZONE_RADIUS:New(destroyZoneName, coord:GetVec2(), 500)
    destroyZoneCount = destroyZoneCount + 1
	--trigger.action.outText("UNIT(S) on your MAP MARKER succesfully DESTROYED.", 10)
    local function destroyUnit(unit)
        unit:Destroy()
        return true
    end

    zoneRadiusToDestroy:SearchZone( destroyUnit , Object.Category.UNIT)
end

local destroyVehicleZoneCount = 0
function handleDestroyVehicleRequest(text, coord)
    local destroyZoneName = string.format("destroy %d", destroyVehicleZoneCount)
    local zoneRadiusToDestroy = ZONE_RADIUS:New(destroyZoneName, coord:GetVec2(), 1000)
    destroyVehicleZoneCount = destroyVehicleZoneCount + 1
	--trigger.action.outText("UNIT(S) on your MAP MARKER succesfully DESTROYED.", 10)
    local function destroyUnit(unit)
        unit:Destroy()
        return true
    end

    zoneRadiusToDestroy:SearchZone( destroyUnit , Object.Category.UNIT)
end

local destroyZoneCount = 0
function handleClearRequest(text, coord)
    local destroyZoneName = string.format("destroy %d", destroyZoneCount)
    local zoneRadiusToDestroy = ZONE_RADIUS:New(destroyZoneName, coord:GetVec2(), 6500)
    destroyZoneCount = destroyZoneCount + 1
    --trigger.action.outText("UNIT(S) on your MAP MARKER succesfully DESTROYED.", 10)
    local function destroyUnit(unit)
        unit:Destroy()
        return true
    end

    zoneRadiusToDestroy:SearchZone( destroyUnit , Object.Category.UNIT)
end

function markRemoved(Event)
    if Event.text~=nil and Event.text:lower():find("-") then 
	    local text = Event.text:lower()
		
        local vec3= {y =Event.pos.y, x=Event.pos.x, z=Event.pos.z}
        local coord = COORDINATE:NewFromVec3(vec3)
        coord.y = coord:GetLandHeight()

        if Event.text:lower():find("-create") then
            handleSpawnRequest(text, coord)
        --STATIC SPAWN START   
        elseif Event.text:lower():find("-static") then
            handleStaticRequest(text, coord)  
        --STATIC SPAWN END  
        elseif Event.text:lower():find("-debug") then
            handleDebugRequest(text, coord) 
        elseif Event.text:lower():find("-destroy1") then
            handleDestroyRequest(text, coord)
		elseif Event.text:lower():find("-destroy2") then
            handleDestroyVehicleRequest(text, coord)
        elseif Event.text:lower():find("-destroy3") then
            handleClearRequest(text, coord)    
        end
    end
end

function SupportHandler:onEvent(Event)
    if Event.id == world.event.S_EVENT_MARK_ADDED then
        -- env.info(string.format("BTI: Support got event ADDED id %s idx %s coalition %s group %s text %s", Event.id, Event.idx, Event.coalition, Event.groupID, Event.text))
    elseif Event.id == world.event.S_EVENT_MARK_CHANGE then
        -- env.info(string.format("BTI: Support got event CHANGE id %s idx %s coalition %s group %s text %s", Event.id, Event.idx, Event.coalition, Event.groupID, Event.text))
    elseif Event.id == world.event.S_EVENT_MARK_REMOVED then
        -- env.info(string.format("BTI: Support got event REMOVED id %s idx %s coalition %s group %s text %s", Event.id, Event.idx, Event.coalition, Event.groupID, Event.text))
        markRemoved(Event)
    end
end

world.addEventHandler(SupportHandler)

-- Function to check and destroy JTAC groups
local function checkAndDestroyJTACGroups()
    -- Get all groups in the mission with names starting with 'JTAC'
    local jtacGroups = SET_GROUP:New():FilterPrefixes('JTAC9lineam'):FilterStart()

    -- Check if any JTAC groups were found
    if jtacGroups:Count() > 0 then
        -- Iterate through each JTAC group and destroy the whole group
        jtacGroups:ForEachGroup(
            function(jtacGroup)
                -- Destroy the entire JTAC group
                jtacGroup:Destroy()
                env.info('JTAC9line group "' .. jtacGroup:GetName() .. '" destroyed after 60 minutes')
            end
        )
    else
        env.info('No JTAC groups found')
    end
end

-- Set up a scheduler to run the checkAndDestroyJTACGroups function every 60 seconds
SCHEDULER:New(nil, checkAndDestroyJTACGroups, {}, 60, 3600)

-- Function to check and destroy JTAC groups
local function checkAndDestroyJTACGroups()
    -- Get all groups in the mission with names starting with 'JTAC'
    local jtacGroups = SET_GROUP:New():FilterPrefixes('JTAC9linefm'):FilterStart()

    -- Check if any JTAC groups were found
    if jtacGroups:Count() > 0 then
        -- Iterate through each JTAC group and destroy the whole group
        jtacGroups:ForEachGroup(
            function(jtacGroup)
                -- Destroy the entire JTAC group
                jtacGroup:Destroy()
                env.info('JTAC9line group "' .. jtacGroup:GetName() .. '" destroyed after 60 minutes')
            end
        )
    else
        env.info('No JTAC groups found')
    end
end

-- Set up a scheduler to run the checkAndDestroyJTACGroups function every 60 seconds
SCHEDULER:New(nil, checkAndDestroyJTACGroups, {}, 60, 3600)

env.info("ZEUS START: is completed!")